/*
 * coproc.h --
 *
 *	Declarations of ...
 *
 * Copyright 1990 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/coproc.h,v 1.1 1996/11/06 22:00:31 hari Exp $ SPRITE (Berkeley)
 */

#ifndef COPROC_H
#define COPROC_H

#include <setjmp.h>
#include <stddef.h>

#define STACKSIZE	4096
#define WARNSTACKLIMIT	 512 

typedef struct {
    jmp_buf	env;
    int		sp[STACKSIZE];
} COPROCtype;

#define SP_OFF 2
#define FP_OFF 3

#define CreateCoproc(p) (!Setjmp((p)->env) ? CreateCoproc2(p) : 0)

#ifndef	__cplusplus
int Setjmp();
extern COPROCtype *CreateCoproc2();
extern void SwitchCoproc();
#else
extern "C" int Setjmp();
extern "C" COPROCtype *CreateCoproc2();
extern "C" void SwitchCoproc();
#endif

#endif COPROC_H
