/*
 * genqueue.h --
 *
 *	Declarations of ...
 *
 * Copyright 1990 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/genqueue.h,v 1.1 1996/11/06 22:00:31 hari Exp $ SPRITE (Berkeley)
 */

#ifndef GENQUEUE_H
#define GENQUEUE_H

typedef struct {
    void      (*initQueue)();
    void      (*enqueue)();
    int      *(*dequeue)();
    int		size;		/* size of queue header structure */
    int	       *queue;		/* header to be copied before calling */
				/* initQueue.  Allows queueing routines */
				/* to be parameterized. */
} GenQueue;

extern GenQueue genPriQueue;
extern GenQueue genLifoQueue;
extern GenQueue genFifoQueue;

#endif /* GENQUEUE_H */
