/*
 * fork.h --
 *
 * Copyright 1990 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/fork.h,v 1.1 1996/11/06 22:00:31 hari Exp $ SPRITE (Berkeley)
 */

#include "event.h"
#include "schedule.h"

extern char *malloc();

typedef struct {
    ProcProc	*parentProc;
    int		 numChildren;
    Event	*joinEvent;
} ForkCtrlBlock;

#define Fork(forkCtrl, name) ((forkCtrl)->numChildren++, Spawn(name))

ForkCtrlBlock *AllocForkCtrl();
void FreeForkCtrlBlock();
void Join();
