/***********************************************************************
 *
 * libsim.h
 *
 *	Definitions for routines in libsim.  These are necessary only
 *	for C++.
 *
 * Copyright 1992 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/libsim.h,v 1.1 1996/11/06 22:00:31 hari Exp $
 *
 ***********************************************************************
 */

#ifndef	_libsim_h_
#define	_libsim_h_

#include "mycompat.h"

Cextern void		InitSim ();
Cextern void		Terminate ();
Cextern void		ResetRequestStat ();
Cextern void		ResetResourceStat ();
Cextern void		CauseEvent ();
Cextern void		WaitEvent ();
Cextern void		FreeEvent ();

#define	SimCurrentTime()	LocalTime()

#endif
