/*
 * semaphore.h --
 *
 * Copyright 1990 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/semaphore.h,v 1.1 1996/11/06 22:00:31 hari Exp $ SPRITE (Berkeley)
 */

#ifndef SEMAPHORE_H
#define SEMAPHORE_H

#include "genqueue.h"

typedef struct {
    int		semaVal;
    GenQueue    genQueue;
} Sema;

#define ValSema(sema) ((sema)->semaVal)
#define LockSema(sema) (DownSema(sema))
#define UnlockSema(sema) (UpSema(sema))

extern void InitSema (/* sema, genQueue, initVal */);
extern void UpSema (/* sema */);
extern void DownSema (/* sema */);
extern void DownSemaFunc (/* sema funcProc */);

#endif SEMAPHORE_H
