#ifndef SEMLIB
#define SEMLIB


#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

typedef int SEM_ID;
typedef int SEM_Status;

extern SEM_ID *Sem_New(key_t key, int initVal);
extern SEM_ID *Sem_Open(key_t key);
extern void Sem_Free(SEM_ID *idPtr);
extern void Sem_Close(SEM_ID *idPtr);
extern void Sem_P(SEM_ID *idPtr);
extern void Sem_V(SEM_ID *idPtr);
extern void Sem_Op(SEM_ID *idPtr, int value);


#endif
