#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/protosw.h>
#include <sys/socket.h>

#include <net/if.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include <net/route.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip_var.h>
#include <netinet/if_ether.h>

#include <arpa/inet.h>

#include <math.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <kvm.h>
#include <limits.h>
#include <netdb.h>
#include <nlist.h>
#include <paths.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ip_mobile.h"
#include "easysocklib.h"
#include "option.h"
#include "dbgprintlib.h"

#include "wroute.h"
#include "beacon.h"
#include "encap.h"
#include "sample.h"


main(int argc, char *argv[])
{
     Socket *sdPtr,*cdPtr;
     int j;
     mobileip_ids ids;

     sdPtr = Sock_Socket(SOCK_UDP_MULTI);
     j = sizeof(ids);
     printf("hit key to get\n");
     getc(stdin);
     if (getsockopt(Sock_GetFD(sdPtr), 
		    IPPROTO_IP, IP_GET_IDS, 
		    (char *)&ids,&j) < 0)
	  perror("Sock_Socket: ip ids");
     printf("got ids: %d: %d %d %d %d\n", ids.lst_pkt, ids.ip_id[0],
	    ids.ip_id[1], ids.ip_id[2]);
     printf("hit key to end\n");
     getc(stdin);
     exit(0);
}

